# autogenerated by genmsg_py from MoveArmAction.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime
import actionlib_msgs.msg
import motion_planning_msgs.msg
import geometric_shapes_msgs.msg
import geometry_msgs.msg
import sensor_msgs.msg
import roslib.msg
import move_arm_msgs.msg

class MoveArmAction(roslib.message.Message):
  _md5sum = "086800a7cf582337e23233e1c1043e63"
  _type = "move_arm_msgs/MoveArmAction"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
MoveArmActionGoal action_goal
MoveArmActionResult action_result
MoveArmActionFeedback action_feedback

================================================================================
MSG: move_arm_msgs/MoveArmActionGoal

Header header
actionlib_msgs/GoalID goal_id
MoveArmGoal goal

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: move_arm_msgs/MoveArmGoal
# Service name to call for getting a motion plan
# Move arm will call a service on this service name 
# using the MotionPlanRequest specified here
string planner_service_name

# A motion planning request
motion_planning_msgs/MotionPlanRequest motion_plan_request

# OPTIONAL flag
# Setting this flag to true will allow move_arm to accept plans that do not go all the way to the goal
bool accept_partial_plans

# OPTIONAL flag
# Setting this flag to true will allow move_arm to accept invalid goals
# This is useful if you are using a planner like CHOMP along with a noisy rapidly changing collision map
# and you would like to plan to a goal near an object.
bool accept_invalid_goals

# OPTIONAL flag
# Setting this flag to true will disable the call to IK for a pose goal
bool disable_ik

# OPTIONAL flag
# Setting this flag to true will disable collision monitoring during execution of a trajectory
bool disable_collision_monitoring
================================================================================
MSG: motion_planning_msgs/MotionPlanRequest
# This service contains the definition for a request to the motion
# planner and the output it provides

# Parameters for the workspace that the planner should work inside
motion_planning_msgs/WorkspaceParameters workspace_parameters

# Starting state updates. If certain joints should be considered
# at positions other than the current ones, these positions should
# be set here
motion_planning_msgs/RobotState start_state

# The goal state for the model to plan for. The goal is achieved
# if all constraints are satisfied
motion_planning_msgs/Constraints goal_constraints

# No state at any point along the path in the produced motion plan will violate these constraints
motion_planning_msgs/Constraints path_constraints

# A specification for regions where contact is 
# allowed upto a certain depth
# Any collision within this set of regions with a link 
# specified in the message will be allowed if
# it is less than the penetration depth specified in the message
AllowedContactSpecification[] allowed_contacts

# A set of ordered collision operations, 
# these are applied to all links, objects, 
# namespaces in the collision space
OrderedCollisionOperations ordered_collision_operations

# The name of the motion planner to use. If no name is specified,
# a default motion planner will be used
string planner_id

# The name of the group of joints on which this planner is operating
string group_name

# The number of times this plan is to be computed. Shortest solution
# will be reported.
int32 num_planning_attempts

# The maximum amount of time the motion planner is allowed to plan for
duration allowed_planning_time

# An expected path duration (in seconds) along with an expected discretization of the path allows the planner to determine the discretization of the trajectory that it returns
duration expected_path_duration
duration expected_path_dt

================================================================================
MSG: motion_planning_msgs/WorkspaceParameters
# This message contains a set of parameters useful in
# setting up the workspace for planning
geometric_shapes_msgs/Shape  workspace_region_shape
geometry_msgs/PoseStamped    workspace_region_pose


================================================================================
MSG: geometric_shapes_msgs/Shape
byte SPHERE=0
byte BOX=1
byte CYLINDER=2
byte MESH=3

byte type


#### define sphere, box, cylinder ####
# the origin of each shape is considered at the shape's center

# for sphere
# radius := dimensions[0]

# for cylinder
# radius := dimensions[0]
# length := dimensions[1]
# the length is along the Z axis

# for box
# size_x := dimensions[0]
# size_y := dimensions[1]
# size_z := dimensions[2]
float64[] dimensions


#### define mesh ####

# list of triangles; triangle k is defined by tre vertices located
# at indices triangles[3k], triangles[3k+1], triangles[3k+2]
int32[] triangles
geometry_msgs/Point[] vertices

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: motion_planning_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state
motion_planning_msgs/MultiDOFJointState multi_dof_joint_state
================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint is defined by:
#  * the position of the joint, 
#  * the velocity of the joint and 
#  * the effort that is applied in the joint.
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: motion_planning_msgs/MultiDOFJointState
#A representation of a multi-dof joint state
time stamp
string joint_name
string frame_id
string child_frame_id
geometry_msgs/Pose pose

================================================================================
MSG: motion_planning_msgs/Constraints
# This message contains a list of motion planning constraints.

motion_planning_msgs/JointConstraint[] joint_constraints
motion_planning_msgs/PositionConstraint[] position_constraints
motion_planning_msgs/OrientationConstraint[] orientation_constraints

================================================================================
MSG: motion_planning_msgs/JointConstraint
# Constrain the position of a joint to be within a certain bound
string joint_name

# the bound to be achieved is [position - tolerance_below, position + tolerance_above]
float64 position
float64 tolerance_above
float64 tolerance_below

# A weighting factor for this constraint
float64 weight
================================================================================
MSG: motion_planning_msgs/PositionConstraint
# This message contains the definition of a position constraint.
Header header

# The robot link this constraint refers to
string link_name

# The offset (in the link frame) for the target point on the link we are planning for
geometry_msgs/Point target_point_offset

# The nominal/target position for the point we are planning for
geometry_msgs/Point position

# The shape of the bounded region that constrains the position of the end-effector
# This region is always centered at the position defined above
geometric_shapes_msgs/Shape constraint_region_shape

# The orientation of the bounded region that constrains the position of the end-effector. 
# This allows the specification of non-axis aligned constraints
geometry_msgs/Quaternion constraint_region_orientation

# Constraint weighting factor - a weight for this constraint
float64 weight
================================================================================
MSG: motion_planning_msgs/OrientationConstraint
# This message contains the definition of an orientation constraint.
Header header

# The robot link this constraint refers to
string link_name

# The type of the constraint
int32 type
int32 LINK_FRAME=0
int32 HEADER_FRAME=1

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# optional RPY error tolerances specified if 
float64 absolute_roll_tolerance
float64 absolute_pitch_tolerance
float64 absolute_yaw_tolerance

# Constraint weighting factor - a weight for this constraint
float64 weight

================================================================================
MSG: motion_planning_msgs/AllowedContactSpecification
# The names of the regions
string name

# The shape of the region in the environment
geometric_shapes_msgs/Shape shape

# The pose of the space defining the region
geometry_msgs/PoseStamped pose_stamped

# The set of links that will be allowed to have penetration contact within this region
string[] link_names

# The maximum penetration depth allowed for every link
float64 penetration_depth
================================================================================
MSG: motion_planning_msgs/OrderedCollisionOperations
# A set of collision operations that will be performed in the order they are specified
CollisionOperation[] collision_operations
================================================================================
MSG: motion_planning_msgs/CollisionOperation
# A definition of a collision operation
# E.g. ("gripper",COLLISION_SET_ALL,ENABLE) will enable collisions 
# between the gripper and all objects in the collision space

string object1
string object2
string COLLISION_SET_ALL="all"
string COLLISION_SET_OBJECTS="objects"
string COLLISION_SET_ATTACHED_OBJECTS="attached"

# The penetration distance to which collisions are allowed. This is 0.0 by default.
float64 penetration_distance

# Flag that determines whether collisions will be enabled or disabled for the pair of objects specified above
int32 operation
int32 DISABLE=0
int32 ENABLE=1

================================================================================
MSG: move_arm_msgs/MoveArmActionResult

Header header
actionlib_msgs/GoalStatus status
MoveArmResult result

================================================================================
MSG: actionlib_msgs/GoalStatus
GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: move_arm_msgs/MoveArmResult
# An error code reflecting what went wrong
motion_planning_msgs/ArmNavigationErrorCodes error_code
================================================================================
MSG: motion_planning_msgs/ArmNavigationErrorCodes
int32 val

# overall behavior
int32 PLANNING_FAILED=-1
int32 SUCCESS=1
int32 TIMED_OUT=-2

# start state errors
int32 START_STATE_IN_COLLISION=-3
int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-4

# goal errors
int32 GOAL_IN_COLLISION=-5
int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-6

# robot state
int32 INVALID_ROBOT_STATE=-7
int32 INCOMPLETE_ROBOT_STATE=-8

# planning request errors
int32 INVALID_PLANNER_ID=-9
int32 INVALID_NUM_PLANNING_ATTEMPTS=-10
int32 INVALID_ALLOWED_PLANNING_TIME=-11
int32 INVALID_GROUP_NAME=-12
int32 INVALID_GOAL_JOINT_CONSTRAINTS=-13
int32 INVALID_GOAL_POSITION_CONSTRAINTS=-14
int32 INVALID_GOAL_ORIENTATION_CONSTRAINTS=-15
int32 INVALID_PATH_JOINT_CONSTRAINTS=-16
int32 INVALID_PATH_POSITION_CONSTRAINTS=-17
int32 INVALID_PATH_ORIENTATION_CONSTRAINTS=-18

# state/trajectory monitor errors
int32 INVALID_TRAJECTORY=-19
int32 INVALID_INDEX=-20
int32 JOINT_LIMITS_VIOLATED=-21
int32 PATH_CONSTRAINTS_VIOLATED=-22
int32 COLLISION_CONSTRAINTS_VIOLATED=-23
int32 GOAL_CONSTRAINTS_VIOLATED=-24
int32 JOINTS_NOT_MOVING=-25
int32 TRAJECTORY_CONTROLLER_FAILED=-26

# system errors
int32 FRAME_TRANSFORM_FAILURE=-27
int32 COLLISION_CHECKING_UNAVAILABLE=-28
int32 ROBOT_STATE_STALE=-29
int32 SENSOR_INFO_STALE=-30

# kinematics errors
int32 NO_IK_SOLUTION=-31
int32 INVALID_LINK_NAME=-32
int32 IK_LINK_IN_COLLISION=-33
int32 NO_FK_SOLUTION=-34
int32 KINEMATICS_STATE_IN_COLLISION=-35

# general errors
int32 INVALID_TIMEOUT=-36


================================================================================
MSG: move_arm_msgs/MoveArmActionFeedback

Header header
actionlib_msgs/GoalStatus status
MoveArmFeedback feedback

================================================================================
MSG: move_arm_msgs/MoveArmFeedback
# The internal state that the move arm action currently is in
string state

# Time to completion - this is a combination of requested planning time and trajectory completion time
duration time_to_completion

"""
  __slots__ = ['action_goal','action_result','action_feedback']
  _slot_types = ['move_arm_msgs/MoveArmActionGoal','move_arm_msgs/MoveArmActionResult','move_arm_msgs/MoveArmActionFeedback']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   action_goal,action_result,action_feedback
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(MoveArmAction, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.action_goal is None:
        self.action_goal = move_arm_msgs.msg.MoveArmActionGoal()
      if self.action_result is None:
        self.action_result = move_arm_msgs.msg.MoveArmActionResult()
      if self.action_feedback is None:
        self.action_feedback = move_arm_msgs.msg.MoveArmActionFeedback()
    else:
      self.action_goal = move_arm_msgs.msg.MoveArmActionGoal()
      self.action_result = move_arm_msgs.msg.MoveArmActionResult()
      self.action_feedback = move_arm_msgs.msg.MoveArmActionFeedback()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.action_goal.header.seq, self.action_goal.header.stamp.secs, self.action_goal.header.stamp.nsecs))
      length = len(self.action_goal.header.frame_id)
      #serialize self.action_goal.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.header.frame_id))
      buff.write(struct.pack('<2I', self.action_goal.goal_id.stamp.secs, self.action_goal.goal_id.stamp.nsecs))
      length = len(self.action_goal.goal_id.id)
      #serialize self.action_goal.goal_id.id
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal_id.id))
      length = len(self.action_goal.goal.planner_service_name)
      #serialize self.action_goal.goal.planner_service_name
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.planner_service_name))
      buff.write(struct.pack('<b', self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.type))
      #serialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions
      length = len(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions))
      #serialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles
      length = len(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles)
      buff.write(struct.pack('<I', length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles))
      #serialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices
      length = len(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      buff.write(struct.pack('<3I', self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.seq, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.secs, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.nsecs))
      length = len(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.frame_id)
      #serialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.frame_id))
      buff.write(struct.pack('<7d3I', self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.x, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.y, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.z, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.x, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.y, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.z, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.w, self.action_goal.goal.motion_plan_request.start_state.joint_state.header.seq, self.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.secs, self.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.nsecs))
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.header.frame_id)
      #serialize self.action_goal.goal.motion_plan_request.start_state.joint_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.motion_plan_request.start_state.joint_state.header.frame_id))
      #serialize self.action_goal.goal.motion_plan_request.start_state.joint_state.name
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.start_state.joint_state.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.action_goal.goal.motion_plan_request.start_state.joint_state.position
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.action_goal.goal.motion_plan_request.start_state.joint_state.position))
      #serialize self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity))
      #serialize self.action_goal.goal.motion_plan_request.start_state.joint_state.effort
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.action_goal.goal.motion_plan_request.start_state.joint_state.effort))
      buff.write(struct.pack('<2I', self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.secs, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.nsecs))
      length = len(self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.joint_name)
      #serialize self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.joint_name))
      length = len(self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.frame_id)
      #serialize self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.frame_id))
      length = len(self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.child_frame_id)
      #serialize self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.child_frame_id))
      buff.write(struct.pack('<7d', self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.x, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.y, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.z, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.x, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.y, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.z, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.w))
      #serialize self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints
      length = len(self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<4d', val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight))
      #serialize self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints
      length = len(self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<3d', val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z))
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<b', val1.constraint_region_shape.type))
        #serialize val1.constraint_region_shape.dimensions
        length = len(val1.constraint_region_shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.constraint_region_shape.dimensions))
        #serialize val1.constraint_region_shape.triangles
        length = len(val1.constraint_region_shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *val1.constraint_region_shape.triangles))
        #serialize val1.constraint_region_shape.vertices
        length = len(val1.constraint_region_shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.constraint_region_shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<4d', val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w))
        buff.write(struct.pack('<d', val1.weight))
      #serialize self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints
      length = len(self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<i', val1.type))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
        buff.write(struct.pack('<4d', val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight))
      #serialize self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints
      length = len(self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<4d', val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight))
      #serialize self.action_goal.goal.motion_plan_request.path_constraints.position_constraints
      length = len(self.action_goal.goal.motion_plan_request.path_constraints.position_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.path_constraints.position_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<3d', val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z))
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<b', val1.constraint_region_shape.type))
        #serialize val1.constraint_region_shape.dimensions
        length = len(val1.constraint_region_shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.constraint_region_shape.dimensions))
        #serialize val1.constraint_region_shape.triangles
        length = len(val1.constraint_region_shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *val1.constraint_region_shape.triangles))
        #serialize val1.constraint_region_shape.vertices
        length = len(val1.constraint_region_shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.constraint_region_shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<4d', val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w))
        buff.write(struct.pack('<d', val1.weight))
      #serialize self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints
      length = len(self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<i', val1.type))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
        buff.write(struct.pack('<4d', val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight))
      #serialize self.action_goal.goal.motion_plan_request.allowed_contacts
      length = len(self.action_goal.goal.motion_plan_request.allowed_contacts)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.allowed_contacts:
        length = len(val1.name)
        #serialize val1.name
        buff.write(struct.pack('<I%ss'%length, length, val1.name))
        buff.write(struct.pack('<b', val1.shape.type))
        #serialize val1.shape.dimensions
        length = len(val1.shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.shape.dimensions))
        #serialize val1.shape.triangles
        length = len(val1.shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *val1.shape.triangles))
        #serialize val1.shape.vertices
        length = len(val1.shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<I', val1.pose_stamped.header.seq))
        buff.write(struct.pack('<2I', val1.pose_stamped.header.stamp.secs, val1.pose_stamped.header.stamp.nsecs))
        length = len(val1.pose_stamped.header.frame_id)
        #serialize val1.pose_stamped.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.pose_stamped.header.frame_id))
        buff.write(struct.pack('<3d', val1.pose_stamped.pose.position.x, val1.pose_stamped.pose.position.y, val1.pose_stamped.pose.position.z))
        buff.write(struct.pack('<4d', val1.pose_stamped.pose.orientation.x, val1.pose_stamped.pose.orientation.y, val1.pose_stamped.pose.orientation.z, val1.pose_stamped.pose.orientation.w))
        #serialize val1.link_names
        length = len(val1.link_names)
        buff.write(struct.pack('<I', length))
        for val2 in val1.link_names:
          length = len(val2)
          #serialize val2
          buff.write(struct.pack('<I%ss'%length, length, val2))
        buff.write(struct.pack('<d', val1.penetration_depth))
      #serialize self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations
      length = len(self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations:
        length = len(val1.object1)
        #serialize val1.object1
        buff.write(struct.pack('<I%ss'%length, length, val1.object1))
        length = len(val1.object2)
        #serialize val1.object2
        buff.write(struct.pack('<I%ss'%length, length, val1.object2))
        buff.write(struct.pack('<di', val1.penetration_distance, val1.operation))
      length = len(self.action_goal.goal.motion_plan_request.planner_id)
      #serialize self.action_goal.goal.motion_plan_request.planner_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.motion_plan_request.planner_id))
      length = len(self.action_goal.goal.motion_plan_request.group_name)
      #serialize self.action_goal.goal.motion_plan_request.group_name
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.motion_plan_request.group_name))
      buff.write(struct.pack('<7i4B3I', self.action_goal.goal.motion_plan_request.num_planning_attempts, self.action_goal.goal.motion_plan_request.allowed_planning_time.secs, self.action_goal.goal.motion_plan_request.allowed_planning_time.nsecs, self.action_goal.goal.motion_plan_request.expected_path_duration.secs, self.action_goal.goal.motion_plan_request.expected_path_duration.nsecs, self.action_goal.goal.motion_plan_request.expected_path_dt.secs, self.action_goal.goal.motion_plan_request.expected_path_dt.nsecs, self.action_goal.goal.accept_partial_plans, self.action_goal.goal.accept_invalid_goals, self.action_goal.goal.disable_ik, self.action_goal.goal.disable_collision_monitoring, self.action_result.header.seq, self.action_result.header.stamp.secs, self.action_result.header.stamp.nsecs))
      length = len(self.action_result.header.frame_id)
      #serialize self.action_result.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_result.header.frame_id))
      buff.write(struct.pack('<2I', self.action_result.status.goal_id.stamp.secs, self.action_result.status.goal_id.stamp.nsecs))
      length = len(self.action_result.status.goal_id.id)
      #serialize self.action_result.status.goal_id.id
      buff.write(struct.pack('<I%ss'%length, length, self.action_result.status.goal_id.id))
      buff.write(struct.pack('<B', self.action_result.status.status))
      length = len(self.action_result.status.text)
      #serialize self.action_result.status.text
      buff.write(struct.pack('<I%ss'%length, length, self.action_result.status.text))
      buff.write(struct.pack('<i3I', self.action_result.result.error_code.val, self.action_feedback.header.seq, self.action_feedback.header.stamp.secs, self.action_feedback.header.stamp.nsecs))
      length = len(self.action_feedback.header.frame_id)
      #serialize self.action_feedback.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_feedback.header.frame_id))
      buff.write(struct.pack('<2I', self.action_feedback.status.goal_id.stamp.secs, self.action_feedback.status.goal_id.stamp.nsecs))
      length = len(self.action_feedback.status.goal_id.id)
      #serialize self.action_feedback.status.goal_id.id
      buff.write(struct.pack('<I%ss'%length, length, self.action_feedback.status.goal_id.id))
      buff.write(struct.pack('<B', self.action_feedback.status.status))
      length = len(self.action_feedback.status.text)
      #serialize self.action_feedback.status.text
      buff.write(struct.pack('<I%ss'%length, length, self.action_feedback.status.text))
      length = len(self.action_feedback.feedback.state)
      #serialize self.action_feedback.feedback.state
      buff.write(struct.pack('<I%ss'%length, length, self.action_feedback.feedback.state))
      buff.write(struct.pack('<2i', self.action_feedback.feedback.time_to_completion.secs, self.action_feedback.feedback.time_to_completion.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.action_goal is None:
        self.action_goal = move_arm_msgs.msg.MoveArmActionGoal()
      if self.action_result is None:
        self.action_result = move_arm_msgs.msg.MoveArmActionResult()
      if self.action_feedback is None:
        self.action_feedback = move_arm_msgs.msg.MoveArmActionFeedback()
      end = 0
      start = end
      end += 12
      (self.action_goal.header.seq, self.action_goal.header.stamp.secs, self.action_goal.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.action_goal.goal_id.stamp.secs, self.action_goal.goal_id.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal_id.id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal_id.id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.planner_service_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.planner_service_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 1
      (self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.type,) = struct.unpack('<b',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions = struct.unpack(pattern, str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles = struct.unpack(pattern, str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices.append(val1)
      start = end
      end += 12
      (self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.seq, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.secs, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 68
      (self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.x, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.y, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.z, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.x, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.y, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.z, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.w, self.action_goal.goal.motion_plan_request.start_state.joint_state.header.seq, self.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.secs, self.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.nsecs,) = struct.unpack('<7d3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.start_state.joint_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.motion_plan_request.start_state.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.start_state.joint_state.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.start_state.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.action_goal.goal.motion_plan_request.start_state.joint_state.name.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.start_state.joint_state.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.start_state.joint_state.position = struct.unpack(pattern, str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity = struct.unpack(pattern, str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.start_state.joint_state.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.start_state.joint_state.effort = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.secs, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.x, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.y, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.z, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.x, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.y, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.z, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 1
        (val1.constraint_region_shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.constraint_region_shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.dimensions = struct.unpack(pattern, str[start:end])
        #deserialize val1.constraint_region_shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.triangles = struct.unpack(pattern, str[start:end])
        #deserialize val1.constraint_region_shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.constraint_region_shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.constraint_region_shape.vertices.append(val3)
        start = end
        end += 32
        (val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 8
        (val1.weight,) = struct.unpack('<d',str[start:end])
        self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.type,) = struct.unpack('<i',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 32
        (val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.path_constraints.position_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.path_constraints.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 1
        (val1.constraint_region_shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.constraint_region_shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.dimensions = struct.unpack(pattern, str[start:end])
        #deserialize val1.constraint_region_shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.triangles = struct.unpack(pattern, str[start:end])
        #deserialize val1.constraint_region_shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.constraint_region_shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.constraint_region_shape.vertices.append(val3)
        start = end
        end += 32
        (val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 8
        (val1.weight,) = struct.unpack('<d',str[start:end])
        self.action_goal.goal.motion_plan_request.path_constraints.position_constraints.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.type,) = struct.unpack('<i',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 32
        (val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.allowed_contacts
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.allowed_contacts = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.AllowedContactSpecification()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 1
        (val1.shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.shape.dimensions = struct.unpack(pattern, str[start:end])
        #deserialize val1.shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.shape.triangles = struct.unpack(pattern, str[start:end])
        #deserialize val1.shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.shape.vertices.append(val3)
        start = end
        end += 4
        (val1.pose_stamped.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.pose_stamped.header.stamp.secs, val1.pose_stamped.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.pose_stamped.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.pose_stamped.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.pose_stamped.pose.position.x, val1.pose_stamped.pose.position.y, val1.pose_stamped.pose.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 32
        (val1.pose_stamped.pose.orientation.x, val1.pose_stamped.pose.orientation.y, val1.pose_stamped.pose.orientation.z, val1.pose_stamped.pose.orientation.w,) = struct.unpack('<4d',str[start:end])
        #deserialize val1.link_names
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.link_names = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2,) = struct.unpack(pattern, str[start:end])
          val1.link_names.append(val2)
        start = end
        end += 8
        (val1.penetration_depth,) = struct.unpack('<d',str[start:end])
        self.action_goal.goal.motion_plan_request.allowed_contacts.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.CollisionOperation()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object1,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object2
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object2,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 12
        (val1.penetration_distance, val1.operation,) = struct.unpack('<di',str[start:end])
        self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations.append(val1)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.planner_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.motion_plan_request.planner_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.group_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.motion_plan_request.group_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 44
      (self.action_goal.goal.motion_plan_request.num_planning_attempts, self.action_goal.goal.motion_plan_request.allowed_planning_time.secs, self.action_goal.goal.motion_plan_request.allowed_planning_time.nsecs, self.action_goal.goal.motion_plan_request.expected_path_duration.secs, self.action_goal.goal.motion_plan_request.expected_path_duration.nsecs, self.action_goal.goal.motion_plan_request.expected_path_dt.secs, self.action_goal.goal.motion_plan_request.expected_path_dt.nsecs, self.action_goal.goal.accept_partial_plans, self.action_goal.goal.accept_invalid_goals, self.action_goal.goal.disable_ik, self.action_goal.goal.disable_collision_monitoring, self.action_result.header.seq, self.action_result.header.stamp.secs, self.action_result.header.stamp.nsecs,) = struct.unpack('<7i4B3I',str[start:end])
      self.action_goal.goal.accept_partial_plans = bool(self.action_goal.goal.accept_partial_plans)
      self.action_goal.goal.accept_invalid_goals = bool(self.action_goal.goal.accept_invalid_goals)
      self.action_goal.goal.disable_ik = bool(self.action_goal.goal.disable_ik)
      self.action_goal.goal.disable_collision_monitoring = bool(self.action_goal.goal.disable_collision_monitoring)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_result.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_result.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.action_result.status.goal_id.stamp.secs, self.action_result.status.goal_id.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_result.status.goal_id.id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_result.status.goal_id.id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 1
      (self.action_result.status.status,) = struct.unpack('<B',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_result.status.text
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_result.status.text,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 16
      (self.action_result.result.error_code.val, self.action_feedback.header.seq, self.action_feedback.header.stamp.secs, self.action_feedback.header.stamp.nsecs,) = struct.unpack('<i3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_feedback.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_feedback.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.action_feedback.status.goal_id.stamp.secs, self.action_feedback.status.goal_id.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_feedback.status.goal_id.id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_feedback.status.goal_id.id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 1
      (self.action_feedback.status.status,) = struct.unpack('<B',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_feedback.status.text
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_feedback.status.text,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_feedback.feedback.state
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_feedback.feedback.state,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.action_feedback.feedback.time_to_completion.secs, self.action_feedback.feedback.time_to_completion.nsecs,) = struct.unpack('<2i',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.action_goal.header.seq, self.action_goal.header.stamp.secs, self.action_goal.header.stamp.nsecs))
      length = len(self.action_goal.header.frame_id)
      #serialize self.action_goal.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.header.frame_id))
      buff.write(struct.pack('<2I', self.action_goal.goal_id.stamp.secs, self.action_goal.goal_id.stamp.nsecs))
      length = len(self.action_goal.goal_id.id)
      #serialize self.action_goal.goal_id.id
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal_id.id))
      length = len(self.action_goal.goal.planner_service_name)
      #serialize self.action_goal.goal.planner_service_name
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.planner_service_name))
      buff.write(struct.pack('<b', self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.type))
      #serialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions
      length = len(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions.tostring())
      #serialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles
      length = len(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles)
      buff.write(struct.pack('<I', length))
      pattern = '<%si'%length
      buff.write(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles.tostring())
      #serialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices
      length = len(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      buff.write(struct.pack('<3I', self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.seq, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.secs, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.nsecs))
      length = len(self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.frame_id)
      #serialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.frame_id))
      buff.write(struct.pack('<7d3I', self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.x, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.y, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.z, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.x, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.y, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.z, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.w, self.action_goal.goal.motion_plan_request.start_state.joint_state.header.seq, self.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.secs, self.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.nsecs))
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.header.frame_id)
      #serialize self.action_goal.goal.motion_plan_request.start_state.joint_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.motion_plan_request.start_state.joint_state.header.frame_id))
      #serialize self.action_goal.goal.motion_plan_request.start_state.joint_state.name
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.start_state.joint_state.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.action_goal.goal.motion_plan_request.start_state.joint_state.position
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.action_goal.goal.motion_plan_request.start_state.joint_state.position.tostring())
      #serialize self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity.tostring())
      #serialize self.action_goal.goal.motion_plan_request.start_state.joint_state.effort
      length = len(self.action_goal.goal.motion_plan_request.start_state.joint_state.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.action_goal.goal.motion_plan_request.start_state.joint_state.effort.tostring())
      buff.write(struct.pack('<2I', self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.secs, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.nsecs))
      length = len(self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.joint_name)
      #serialize self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.joint_name))
      length = len(self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.frame_id)
      #serialize self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.frame_id))
      length = len(self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.child_frame_id)
      #serialize self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.child_frame_id))
      buff.write(struct.pack('<7d', self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.x, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.y, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.z, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.x, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.y, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.z, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.w))
      #serialize self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints
      length = len(self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<4d', val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight))
      #serialize self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints
      length = len(self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<3d', val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z))
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<b', val1.constraint_region_shape.type))
        #serialize val1.constraint_region_shape.dimensions
        length = len(val1.constraint_region_shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.constraint_region_shape.dimensions.tostring())
        #serialize val1.constraint_region_shape.triangles
        length = len(val1.constraint_region_shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(val1.constraint_region_shape.triangles.tostring())
        #serialize val1.constraint_region_shape.vertices
        length = len(val1.constraint_region_shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.constraint_region_shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<4d', val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w))
        buff.write(struct.pack('<d', val1.weight))
      #serialize self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints
      length = len(self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<i', val1.type))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
        buff.write(struct.pack('<4d', val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight))
      #serialize self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints
      length = len(self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<4d', val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight))
      #serialize self.action_goal.goal.motion_plan_request.path_constraints.position_constraints
      length = len(self.action_goal.goal.motion_plan_request.path_constraints.position_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.path_constraints.position_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<3d', val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z))
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<b', val1.constraint_region_shape.type))
        #serialize val1.constraint_region_shape.dimensions
        length = len(val1.constraint_region_shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.constraint_region_shape.dimensions.tostring())
        #serialize val1.constraint_region_shape.triangles
        length = len(val1.constraint_region_shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(val1.constraint_region_shape.triangles.tostring())
        #serialize val1.constraint_region_shape.vertices
        length = len(val1.constraint_region_shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.constraint_region_shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<4d', val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w))
        buff.write(struct.pack('<d', val1.weight))
      #serialize self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints
      length = len(self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<i', val1.type))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
        buff.write(struct.pack('<4d', val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight))
      #serialize self.action_goal.goal.motion_plan_request.allowed_contacts
      length = len(self.action_goal.goal.motion_plan_request.allowed_contacts)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.allowed_contacts:
        length = len(val1.name)
        #serialize val1.name
        buff.write(struct.pack('<I%ss'%length, length, val1.name))
        buff.write(struct.pack('<b', val1.shape.type))
        #serialize val1.shape.dimensions
        length = len(val1.shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.shape.dimensions.tostring())
        #serialize val1.shape.triangles
        length = len(val1.shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(val1.shape.triangles.tostring())
        #serialize val1.shape.vertices
        length = len(val1.shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<I', val1.pose_stamped.header.seq))
        buff.write(struct.pack('<2I', val1.pose_stamped.header.stamp.secs, val1.pose_stamped.header.stamp.nsecs))
        length = len(val1.pose_stamped.header.frame_id)
        #serialize val1.pose_stamped.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.pose_stamped.header.frame_id))
        buff.write(struct.pack('<3d', val1.pose_stamped.pose.position.x, val1.pose_stamped.pose.position.y, val1.pose_stamped.pose.position.z))
        buff.write(struct.pack('<4d', val1.pose_stamped.pose.orientation.x, val1.pose_stamped.pose.orientation.y, val1.pose_stamped.pose.orientation.z, val1.pose_stamped.pose.orientation.w))
        #serialize val1.link_names
        length = len(val1.link_names)
        buff.write(struct.pack('<I', length))
        for val2 in val1.link_names:
          length = len(val2)
          #serialize val2
          buff.write(struct.pack('<I%ss'%length, length, val2))
        buff.write(struct.pack('<d', val1.penetration_depth))
      #serialize self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations
      length = len(self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations)
      buff.write(struct.pack('<I', length))
      for val1 in self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations:
        length = len(val1.object1)
        #serialize val1.object1
        buff.write(struct.pack('<I%ss'%length, length, val1.object1))
        length = len(val1.object2)
        #serialize val1.object2
        buff.write(struct.pack('<I%ss'%length, length, val1.object2))
        buff.write(struct.pack('<di', val1.penetration_distance, val1.operation))
      length = len(self.action_goal.goal.motion_plan_request.planner_id)
      #serialize self.action_goal.goal.motion_plan_request.planner_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.motion_plan_request.planner_id))
      length = len(self.action_goal.goal.motion_plan_request.group_name)
      #serialize self.action_goal.goal.motion_plan_request.group_name
      buff.write(struct.pack('<I%ss'%length, length, self.action_goal.goal.motion_plan_request.group_name))
      buff.write(struct.pack('<7i4B3I', self.action_goal.goal.motion_plan_request.num_planning_attempts, self.action_goal.goal.motion_plan_request.allowed_planning_time.secs, self.action_goal.goal.motion_plan_request.allowed_planning_time.nsecs, self.action_goal.goal.motion_plan_request.expected_path_duration.secs, self.action_goal.goal.motion_plan_request.expected_path_duration.nsecs, self.action_goal.goal.motion_plan_request.expected_path_dt.secs, self.action_goal.goal.motion_plan_request.expected_path_dt.nsecs, self.action_goal.goal.accept_partial_plans, self.action_goal.goal.accept_invalid_goals, self.action_goal.goal.disable_ik, self.action_goal.goal.disable_collision_monitoring, self.action_result.header.seq, self.action_result.header.stamp.secs, self.action_result.header.stamp.nsecs))
      length = len(self.action_result.header.frame_id)
      #serialize self.action_result.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_result.header.frame_id))
      buff.write(struct.pack('<2I', self.action_result.status.goal_id.stamp.secs, self.action_result.status.goal_id.stamp.nsecs))
      length = len(self.action_result.status.goal_id.id)
      #serialize self.action_result.status.goal_id.id
      buff.write(struct.pack('<I%ss'%length, length, self.action_result.status.goal_id.id))
      buff.write(struct.pack('<B', self.action_result.status.status))
      length = len(self.action_result.status.text)
      #serialize self.action_result.status.text
      buff.write(struct.pack('<I%ss'%length, length, self.action_result.status.text))
      buff.write(struct.pack('<i3I', self.action_result.result.error_code.val, self.action_feedback.header.seq, self.action_feedback.header.stamp.secs, self.action_feedback.header.stamp.nsecs))
      length = len(self.action_feedback.header.frame_id)
      #serialize self.action_feedback.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.action_feedback.header.frame_id))
      buff.write(struct.pack('<2I', self.action_feedback.status.goal_id.stamp.secs, self.action_feedback.status.goal_id.stamp.nsecs))
      length = len(self.action_feedback.status.goal_id.id)
      #serialize self.action_feedback.status.goal_id.id
      buff.write(struct.pack('<I%ss'%length, length, self.action_feedback.status.goal_id.id))
      buff.write(struct.pack('<B', self.action_feedback.status.status))
      length = len(self.action_feedback.status.text)
      #serialize self.action_feedback.status.text
      buff.write(struct.pack('<I%ss'%length, length, self.action_feedback.status.text))
      length = len(self.action_feedback.feedback.state)
      #serialize self.action_feedback.feedback.state
      buff.write(struct.pack('<I%ss'%length, length, self.action_feedback.feedback.state))
      buff.write(struct.pack('<2i', self.action_feedback.feedback.time_to_completion.secs, self.action_feedback.feedback.time_to_completion.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.action_goal is None:
        self.action_goal = move_arm_msgs.msg.MoveArmActionGoal()
      if self.action_result is None:
        self.action_result = move_arm_msgs.msg.MoveArmActionResult()
      if self.action_feedback is None:
        self.action_feedback = move_arm_msgs.msg.MoveArmActionFeedback()
      end = 0
      start = end
      end += 12
      (self.action_goal.header.seq, self.action_goal.header.stamp.secs, self.action_goal.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.action_goal.goal_id.stamp.secs, self.action_goal.goal_id.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal_id.id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal_id.id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.planner_service_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.planner_service_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 1
      (self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.type,) = struct.unpack('<b',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      #deserialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_shape.vertices.append(val1)
      start = end
      end += 12
      (self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.seq, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.secs, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 68
      (self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.x, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.y, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.position.z, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.x, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.y, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.z, self.action_goal.goal.motion_plan_request.workspace_parameters.workspace_region_pose.pose.orientation.w, self.action_goal.goal.motion_plan_request.start_state.joint_state.header.seq, self.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.secs, self.action_goal.goal.motion_plan_request.start_state.joint_state.header.stamp.nsecs,) = struct.unpack('<7d3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.start_state.joint_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.motion_plan_request.start_state.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.start_state.joint_state.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.start_state.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.action_goal.goal.motion_plan_request.start_state.joint_state.name.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.start_state.joint_state.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.start_state.joint_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.start_state.joint_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.action_goal.goal.motion_plan_request.start_state.joint_state.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.motion_plan_request.start_state.joint_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 8
      (self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.secs, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.x, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.y, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.position.z, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.x, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.y, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.z, self.action_goal.goal.motion_plan_request.start_state.multi_dof_joint_state.pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.action_goal.goal.motion_plan_request.goal_constraints.joint_constraints.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 1
        (val1.constraint_region_shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.constraint_region_shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.constraint_region_shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        #deserialize val1.constraint_region_shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.constraint_region_shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.constraint_region_shape.vertices.append(val3)
        start = end
        end += 32
        (val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 8
        (val1.weight,) = struct.unpack('<d',str[start:end])
        self.action_goal.goal.motion_plan_request.goal_constraints.position_constraints.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.type,) = struct.unpack('<i',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 32
        (val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.action_goal.goal.motion_plan_request.goal_constraints.orientation_constraints.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.action_goal.goal.motion_plan_request.path_constraints.joint_constraints.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.path_constraints.position_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.path_constraints.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 1
        (val1.constraint_region_shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.constraint_region_shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.constraint_region_shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        #deserialize val1.constraint_region_shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.constraint_region_shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.constraint_region_shape.vertices.append(val3)
        start = end
        end += 32
        (val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 8
        (val1.weight,) = struct.unpack('<d',str[start:end])
        self.action_goal.goal.motion_plan_request.path_constraints.position_constraints.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.type,) = struct.unpack('<i',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 32
        (val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.action_goal.goal.motion_plan_request.path_constraints.orientation_constraints.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.allowed_contacts
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.allowed_contacts = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.AllowedContactSpecification()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 1
        (val1.shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.shape.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.shape.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        #deserialize val1.shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.shape.vertices.append(val3)
        start = end
        end += 4
        (val1.pose_stamped.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.pose_stamped.header.stamp.secs, val1.pose_stamped.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.pose_stamped.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.pose_stamped.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.pose_stamped.pose.position.x, val1.pose_stamped.pose.position.y, val1.pose_stamped.pose.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 32
        (val1.pose_stamped.pose.orientation.x, val1.pose_stamped.pose.orientation.y, val1.pose_stamped.pose.orientation.z, val1.pose_stamped.pose.orientation.w,) = struct.unpack('<4d',str[start:end])
        #deserialize val1.link_names
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.link_names = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2,) = struct.unpack(pattern, str[start:end])
          val1.link_names.append(val2)
        start = end
        end += 8
        (val1.penetration_depth,) = struct.unpack('<d',str[start:end])
        self.action_goal.goal.motion_plan_request.allowed_contacts.append(val1)
      #deserialize self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.CollisionOperation()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object1,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object2
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object2,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 12
        (val1.penetration_distance, val1.operation,) = struct.unpack('<di',str[start:end])
        self.action_goal.goal.motion_plan_request.ordered_collision_operations.collision_operations.append(val1)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.planner_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.motion_plan_request.planner_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_goal.goal.motion_plan_request.group_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_goal.goal.motion_plan_request.group_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 44
      (self.action_goal.goal.motion_plan_request.num_planning_attempts, self.action_goal.goal.motion_plan_request.allowed_planning_time.secs, self.action_goal.goal.motion_plan_request.allowed_planning_time.nsecs, self.action_goal.goal.motion_plan_request.expected_path_duration.secs, self.action_goal.goal.motion_plan_request.expected_path_duration.nsecs, self.action_goal.goal.motion_plan_request.expected_path_dt.secs, self.action_goal.goal.motion_plan_request.expected_path_dt.nsecs, self.action_goal.goal.accept_partial_plans, self.action_goal.goal.accept_invalid_goals, self.action_goal.goal.disable_ik, self.action_goal.goal.disable_collision_monitoring, self.action_result.header.seq, self.action_result.header.stamp.secs, self.action_result.header.stamp.nsecs,) = struct.unpack('<7i4B3I',str[start:end])
      self.action_goal.goal.accept_partial_plans = bool(self.action_goal.goal.accept_partial_plans)
      self.action_goal.goal.accept_invalid_goals = bool(self.action_goal.goal.accept_invalid_goals)
      self.action_goal.goal.disable_ik = bool(self.action_goal.goal.disable_ik)
      self.action_goal.goal.disable_collision_monitoring = bool(self.action_goal.goal.disable_collision_monitoring)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_result.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_result.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.action_result.status.goal_id.stamp.secs, self.action_result.status.goal_id.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_result.status.goal_id.id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_result.status.goal_id.id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 1
      (self.action_result.status.status,) = struct.unpack('<B',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_result.status.text
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_result.status.text,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 16
      (self.action_result.result.error_code.val, self.action_feedback.header.seq, self.action_feedback.header.stamp.secs, self.action_feedback.header.stamp.nsecs,) = struct.unpack('<i3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_feedback.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_feedback.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.action_feedback.status.goal_id.stamp.secs, self.action_feedback.status.goal_id.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_feedback.status.goal_id.id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_feedback.status.goal_id.id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 1
      (self.action_feedback.status.status,) = struct.unpack('<B',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_feedback.status.text
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_feedback.status.text,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.action_feedback.feedback.state
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.action_feedback.feedback.state,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.action_feedback.feedback.time_to_completion.secs, self.action_feedback.feedback.time_to_completion.nsecs,) = struct.unpack('<2i',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

